#!/usr/bin/wish
#============================
global OP

if {$argv0 != ""} {
	set app "$argv0"
} else {
	set app [pwd]
}

catch { set app [file readlink "$app"] }

#============================
set title  "NakenChat Client            ::OpenNaken Windows Version 0.70::"
proc init_menu { } {
  frame .menu -relief raised -bd 2 
  pack .menu -side top -padx 1 -pady 1 -fill x
  menubutton .menu.f -text "File" -underline 0 -menu .menu.f.menu
  set a [menu .menu.f.menu -tearoff 0]
  $a add command -label "Save Screen" -underline 0 -command { menuSaveBuffer }
  $a add separator
  $a add command -label Exit -underline 1 -command { exit }
  menubutton .menu.a -text "Chat Colors" -underline 0 -menu .menu.a.menu9
  set b [menu .menu.a.menu9 -tearoff 0]
  $b add command -label "Default Notice Color" -command {init_notice1} 
  $b add command -label "Default Chat Color" -command {init_default1} 
  $b add separator
  $b add cascade -label "Notice Color..." -menu $b.55
  set 55 [menu $b.55 -tearoff 0]
  $55 add command -label "Red" -command {init_colorsa} 
  $55 add command -label "White" -command {init_colorsb}
  $55 add command -label "Blue" -command {init_colorsc}
  $55 add command -label "LightBlue" -command {init_colorsd}
  $55 add command -label "Green" -command {init_colorse}
  $55 add command -label "Yellow" -command {init_colorsf}
  $55 add command -label "Black" -command {init_colorsg}
  $55 add command -label "Gray" -command {init_colorsh}
  $55 add command -label "LightGray" -command {init_colorsi}
  $b add separator
  $b add cascade -label "Background Color..." -menu $b.1
  set 1 [menu $b.1 -tearoff 0]
  $1 add command -label "Red" -command {init_colors1} 
  $1 add command -label "White" -command {init_colors2}
  $1 add cascade -label "Blue" -menu $b.3
  set 3 [menu $b.3 -tearoff 0]
  $3 add command -label "Blue" -command {init_colors3}
  $3 add command -label "LightBlue" -command {init_colors100}
  $1 add command -label "Green" -command {init_colors4}
  $1 add command -label "Yellow" -command {init_colors5}
  $1 add command -label "Black" -command {init_colors6}
  $1 add command -label "Gray" -command {init_colors7}
  $1 add command -label "LightGray" -command {init_colors8}
  $b add separator
  $b add cascade -label "Foreground Color..." -menu $b.2
  set 2 [menu $b.2 -tearoff 0]
  $2 add command -label "Red" -command {init_colors11}
  $2 add command -label "White" -command {init_colors21}
  $2 add cascade -label "Blue" -menu $b.4
  set 4 [menu $b.4 -tearoff 0]
  $4 add command -label "Blue" -command {init_colors31}
  $4 add command -label "LightBlue" -command {init_colors101}
  $2 add command -label "Green" -command {init_colors41}
  $2 add command -label "Yellow" -command {init_colors51}
  $2 add command -label "Black" -command {init_colors61}
  $2 add command -label "Gray" -command {init_colors71}
  $2 add command -label "LightGray" -command {init_colors81}
  menubutton .menu.d -text "Font" -underline 0 -menu .menu.d.menu1
  set d [menu .menu.d.menu1 -tearoff 0]
  $d add cascade -label "Font size 12" -menu $d.12
  set 12 [menu $d.12 -tearoff 0]
  $12 add command -label "Normal" -command {init_font0}
  $12 add command -label "Bold" -command {init_font00}
  $12 add command -label "Italic" -command {init_font000}
  $d add separator
  $d add cascade -label "Font size 13" -menu $d.13
  set 13 [menu $d.13 -tearoff 0]
  $13 add command -label "Normal" -command {init_font1}
  $13 add command -label "Bold" -command {init_font11}
  $13 add command -label "Italic" -command {init_font111}
  $d add separator
  $d add cascade -label "Font size 14" -menu $d.14
  set 14 [menu $d.14 -tearoff 0]
  $14 add command -label "Normal" -command {init_font4}
  $14 add command -label "Bold" -command {init_font44}
  $14 add command -label "Italic" -command {init_font444}
  $d add separator
  $d add cascade -label "Font size 15" -menu $d.15
  set 15 [menu $d.15 -tearoff 0]
  $15 add command -label "Normal" -command {init_font2}
  $15 add command -label "Bold" -command {init_font22}
  $15 add command -label "Italic" -command {init_font222}
  menubutton .menu.c -text "Help Menu" -underline 0 -menu .menu.c.menu1
  set c [menu .menu.c.menu1 -tearoff 0]
  $c add cascade -label "HowTo's" -menu $c.3
  set 3 [menu $c.3 -tearoff 0]
  $3 add command -label "How to Connect" -command {wm deiconify .help}
  $3 add command -label "Server Commands" -command {wm deiconify .helpmenu}
  $3 add command -label "Client Commands" -underline 1 -command {wm deiconify .naken}
  $3 add command -label "Commands" -underline 1 -command {wm deiconify .commands}
  $c add command -label "About..." -underline 2 -command {wm deiconify .logo} 
  pack .menu.f .menu.a .menu.d .menu.c -side left
}
#============================
proc init { } {
  global ON
  global back
  global username
  global userpass
  global conn
  global title
  bind . <Alt-x> exit
  init_menu
  frame .topwindow -relief flat -bd 2
  text .topwindow.chat -width 75 -height 25 -relief raised 
  #canvas .topwindow.chat
  .topwindow.chat config -yscrollcommand ".topwindow.chatsb set"
  bind .topwindow.chat <Button-1> { focus .topwindow.chat }
  bind .topwindow.chat <ButtonPress-1> { puts "click %x %y" }
  bind .topwindow.chat <B1-Motion> { puts "drag %x %y" }
  bind .topwindow.chat <ButtonRelease-1> { puts "drop %x %y" }
  catch {.topwindow.chat configure -font -*-verdana-medium-r-normal--*-130-*}
#===========================
#SET THE LEFT AND RIGHT LOGO IMAGES
#
#DEFAULT4.GIF/LEFT SIDE  
#DEFAULT3.GIF/RIGHT SIDE
#
#===========================
  set logo [image create photo \
	-file [file join images default4.gif]]
  label .topwindow.icon -image $logo
  set logo2 [image create photo \
	-file [file join images default3.gif]]
  label .topwindow.icon2 -image $logo2
  scrollbar .topwindow.chatsb -command ".topwindow.chat yview"

  #text .topwindow.who -relief raised -width 18
  #.topwindow.who config -yscrollcommand ".topwindow.whosb set"
  #scrollbar .topwindow.whosb -command ".topwindow.who yview"

# pack .topwindow.chat .topwindow.chatsb .topwindow.who .topwindow.whosb -side left -fill y

  init_colors
  pack .topwindow.icon -side left 
  pack .topwindow.icon2 -side right 
  pack .topwindow.chat .topwindow.chatsb -side left -fill y
  pack .topwindow -side top -fill y
  #.topwindow.chat create window 218 153  
#===========================  
  frame .frame -relief raised -bd 2 -bg $back
  label .frame.label -text "Name (Username): " -background lightgray  -foreground black -relief flat -padx 8
  entry .frame.name -width 20 -textvariable username -bg $back
  bind .frame.name <Control-KeyPress-x> { exit }
  bind .frame.name <KeyPress-Return> { pass_ok }
  label .frame.label2 -text "Connecting Server: " -background lightgray  -foreground black -relief flat -padx 8
  entry .frame.pass -width 20 -textvariable userpass -bg $back
  bind .frame.pass <KeyPress-Return> { pass_ok }
  label .frame.label3 -text "Port:" -background lightgray  -foreground black -relief flat -padx 8
  entry .frame.port -width 7 -textvariable userport -bg $back
  bind .frame.port <KeyPress-Return> { pass_ok }
  label .frame.label33 -text "" -background lightgray  -foreground black -relief flat -padx 8
  button .frame.submit -text "OK" -command { pass_ok } -padx 8 -bg $back
  bindtags .frame.submit { Button all .frame.submit . }
  bindtags .frame.name { Entry all .frame.name . }
  bind .frame.submit <Return> { pass_ok }
  bind .frame.submit <Tab> { focus .frame.name }
  bind .frame.submit <KeyPress-Return> { focus .frame.submit }
  bind .frame.name <Shift-Tab> { focus .frame.submit }
  pack .frame.label .frame.name .frame.label2 .frame.pass .frame.label3 .frame.port .frame.label33 .frame.submit -side left 
  pack .frame -fill x
  bindtags .topwindow.chat { Text .topwindow.chat . all }
  bind .topwindow.chat <Button-1> { focus .frame.name }
  focus .frame.name

}
#==========================
proc do_loop { } {

  global color
  global count
  global reply
  global conn
  
  if [eof $conn] {
    catch {close $conn}; return
  }
  set reply [gets $conn]
  parse_message

}

proc updatechat { textcomm } {

  global conn
  
  if { $textcomm == "/quit" } {
    catch [close $conn]; exit
  }
  if { $textcomm != "" } {
    puts $conn $textcomm; flush $conn
    .topwindow.chat yview moveto 1
  }
  
}

proc parse_message { } {

  global reply
  
  set str $reply  
  set id [lindex [split $str] 0]
  set str [string range $str 2 end]

switch -exact -- $id {
    ">>" { 
         .topwindow.chat insert end "$reply\n" {red}
         .topwindow.chat yview moveto 1      
    }
    "Name" {
	   .topwindow.chat insert end "$reply\n" {ch}
         .topwindow.chat yview moveto 1      
    }
    "Total:" {
	   .topwindow.chat insert end "$reply\n" {ch}
         .topwindow.chat yview moveto 1      
    }
    "List" {
	   .topwindow.chat insert end "$reply\n" {list}
         .topwindow.chat yview moveto 1      
    }
    "Channels" {
	   .topwindow.chat insert end "$reply\n" {sh}
         .topwindow.chat yview moveto 1      
    }
    "Please" {
	   .topwindow.chat insert end "$reply\n" {list}
         .topwindow.chat yview moveto 1      
    }
    "Version" {
	   .topwindow.chat insert end "$reply\n" {sh}
         .topwindow.chat yview moveto 1      
    }
    "Type" {
	   .topwindow.chat insert end "$reply\n" {list}
         .topwindow.chat yview moveto 1      
    }
    ":" {
	   .topwindow.chat insert end "$reply\n" {dot}
         .topwindow.chat yview moveto 1      
    }
".w" {
	   .topwindow.chat insert end "$reply\n" {dot}
         .topwindow.chat yview moveto 1      
    }
".i" {
	   .topwindow.chat insert end "$reply\n" {dot2}
         .topwindow.chat yview moveto 1      
    }
".n" {
	   .topwindow.chat insert end "$reply\n" {dot2}
         .topwindow.chat yview moveto 1      
    }
".c" {
	   .topwindow.chat insert end "$reply\n" {dot}
         .topwindow.chat yview moveto 1      
    }
".b" {
	   .topwindow.chat insert end "$reply\n" {dot2}
         .topwindow.chat yview moveto 1      
    }
".hu" {
	   .topwindow.chat insert end "$reply\n" {dot}
         .topwindow.chat yview moveto 1      
    }
".y" {
	   .topwindow.chat insert end "$reply\n" {dot2}
         .topwindow.chat yview moveto 1      
    }
".k" {
	   .topwindow.chat insert end "$reply\n" {dot}
         .topwindow.chat yview moveto 1      
    }
".l" {
	   .topwindow.chat insert end "$reply\n" {dot2}
         .topwindow.chat yview moveto 1      
    }
".d" {
	   .topwindow.chat insert end "$reply\n" {dot}
         .topwindow.chat yview moveto 1      
    }
".p" {
	   .topwindow.chat insert end "$reply\n" {dot2}
         .topwindow.chat yview moveto 1      
    }
".o" {
	   .topwindow.chat insert end "$reply\n" {dot}
         .topwindow.chat yview moveto 1      
    }
".t" {
	   .topwindow.chat insert end "$reply\n" {dot2}
         .topwindow.chat yview moveto 1      
    }
".g" {
	   .topwindow.chat insert end "$reply\n" {dot}
         .topwindow.chat yview moveto 1      
    }
".q" {
	   .topwindow.chat insert end "$reply\n" {dot2}
         .topwindow.chat yview moveto 1      
    }
"Main" {
	   .topwindow.chat insert end "$reply\n" {list}
         .topwindow.chat yview moveto 1      
    }

    default {
      if { $reply != "" } {
        .topwindow.chat insert end "$reply\n"
        .topwindow.chat yview moveto 1
      }
     }
   }

}
#======================

set OP(homedir) "[file dirname "$app"]"
set OP(libdir) "$OP(homedir)/config/lib"
set OP(lib2dir) "$OP(homedir)/config/"
set OP(imagesdir} "$OP(homedir)/images"
#set OP(pluginsdir} "$OP(homedir)/plugins"

if ![file exists $OP(homedir)/images] {file mkdir $OP(homedir)/images}
if ![file exists $OP(homedir)/config] {file mkdir $OP(homedir)/config}
if ![file exists $OP(homedir)/config/lib] {file mkdir $OP(homedir)/config/lib}
#if ![file exists $OP(homedir)/plugins] {file mkdir $OP(homedir)/plugins}

#==============================
#	   CONFIG FILES
#==============================
source "$OP(lib2dir)/color.cfg"
source "$OP(lib2dir)/server.cfg"
#==============================
#	   LIB FILES
#==============================
source "$OP(libdir)/font.on"
source "$OP(libdir)/about.on"
source "$OP(libdir)/help.on"
source "$OP(libdir)/commands.on"
source "$OP(libdir)/clientcommands.on"
source "$OP(libdir)/save.on"
source "$OP(libdir)/gif.on"
#======================
global back
set back lightgrey
init
